目录
力扣39. 组合总和
解析代码1
解析代码2
力扣39. 组合总和
39. 组合总和
LCR 081. 组合总和
难度 中等
给你一个 无重复元素 的整数数组 candidates
和一个目标整数 target
,找出 candidates
中可以使数字和为目标数 target
的 所有 不同组合 ,并以列表形式返回。你可以按 任意顺序 返回这些组合。
candidates
中的 同一个 数字可以 无限制重复被选取 。如果至少一个数字的被选数量不同,则两种组合是不同的。
对于给定的输入,保证和为 target
的不同组合数少于 150
个。
示例 1:
输入:candidates = [2,3,6,7], target = 7 输出:[[2,2,3],[7]] 解释: 2 和 3 可以形成一组候选,2 + 2 + 3 = 7 。注意 2 可以使用多次。 7 也是一个候选, 7 = 7 。 仅有这两种组合。
示例 2:
输入: candidates = [2,3,5], target = 8 输出: [[2,2,2,2],[2,3,3],[3,5]]
示例 3:
输入: candidates = [2], target = 1 输出: []
提示:
1 <= candidates.length <= 30
2 <= candidates[i] <= 40
-
candidates
的所有元素 互不相同 1 <= target <= 40
class Solution {
public:
vector<vector<int>> combinationSum(vector<int>& candidates, int target) {
}
};
解析代码1
因此在选择当前元素并向下传递下标时,应该直接传递当前元素下标。
此题算是组合总和1,后面还有组合总和2、3、4,可以自己完成。
candidates 的所有元素互不相同,因此我们在递归状态时只需要对每个元素进行如下判断:
- 跳过,对下一个元素进行判断;
- 将其添加至当前状态中,我们在选择添加当前元素时,之后仍可以继续选择当前元素(可以重复选择同一元素)。
因此在选择当前元素并向下传递下标时,应该直接传递当前元素下标。
class Solution {
int _target;
vector<int> path;
vector<vector<int>> ret;
public:
vector<vector<int>> combinationSum(vector<int>& candidates, int target) {
_target = target;
dfs(candidates, 0, 0);
return ret;
}
void dfs(vector<int>& candidates, int pos, int sum)
{
if(sum > _target)
return;
if(sum == _target)
{
ret.push_back(path);
return;
}
for(int i = pos; i < candidates.size(); ++i)
{
path.push_back(candidates[i]);
dfs(candidates, i, sum + candidates[i]);
path.pop_back();
}
}
};
解析代码2
还可以换一个思路:如
示例 1:
输入: candidates = [2,3,6,7], target = 7 输出: [[7],[2,2,3]]
从选0个2开始,选1、2、3、4...个2,直到sum >= target。
然后在上面选2的个数的基础上开始选3...,直到选完数组的数。所有情况枚举完再恢复现场。文章来源:https://www.toymoban.com/news/detail-861035.html
class Solution {
int _target;
vector<int> path;
vector<vector<int>> ret;
public:
vector<vector<int>> combinationSum(vector<int>& candidates, int target) {
_target = target;
dfs(candidates, 0, 0);
return ret;
}
void dfs(vector<int>& candidates, int pos, int sum)
{
if(sum == _target)
{
ret.push_back(path);
return;
}
if(sum > _target || pos == candidates.size()) // 下面没判断pos这就要判断
return;
for (int k = 0; k * candidates[pos] + sum <= _target; ++k) // 枚举个数
{
if (k != 0)
path.push_back(candidates[pos]);
dfs(candidates, pos + 1, sum + k * candidates[pos]);
}
for (int k = 1; k * candidates[pos] + sum <= _target; ++k) // 恢复现场
{
path.pop_back();
}
}
};
文章来源地址https://www.toymoban.com/news/detail-861035.html
到了这里,关于每日OJ题_DFS回溯剪枝⑨_力扣39. 组合总和(两种思路)的文章就介绍完了。如果您还想了解更多内容,请在右上角搜索TOY模板网以前的文章或继续浏览下面的相关文章,希望大家以后多多支持TOY模板网!